<template>
  <div class="bg-fixed bg-cover bg-no-repeat h-screen w-screen overflow-hidden">
    <div class="bg-gradient-to-br from-rose-100 to-teal-100 h-full overflow-auto">
        <div class="text-center py-10">
            <div class="font-bold text-2xl">
                Jadwal Sholat Indonesia
            </div>
            <div class="px-4">
                <div class="">{{ anyTanggal[0] }}, {{ anyTanggal[2] }} | {{ anyTanggal[1] }}</div>
                <div class="">{{ clock }}</div>
                <div class="py-4 text-center">
                    <input class="my-3 text-lg w-4/6 bg-slate-100 py-2 px-3 rounded" type="text" v-model="messageRaw" @keyup="toSlug()" placeholder="Pesan / Nama Masjid...">
                    <input class="text-lg w-4/6 bg-slate-100 py-2 px-3 rounded" type="text" v-model="input" @keyup="cariKota()" placeholder="Cari Kota...">
                </div>
                <div class="mt-2 grid grid-cols-1 justify-strech md:grid-cols-3 lg:grid-cols-5 grid-flow-row gap-3 justify-center text-center">
                    <div v-for="lokasi in anyLokasi" :key="lokasi.id">
                        <router-link class="py-2 px-4 rounded hover:text-green-600 cursor-pointer" :to="{ name: 'sholat', query:{id: lokasi.id, msg: message} }">{{ lokasi.lokasi }}</router-link>
                    </div>
                </div>
            </div>
        </div>
    </div>
  </div>
</template>

<script setup>
import { useStore } from 'vuex';
import { ref, computed, onMounted } from 'vue';
import moment from 'moment';

moment.locale('id')
const store = useStore()
const messageRaw = ref("")
const message = ref("")
const input = ref("")
const date = ref(moment().format('dddd, DD MMMM YYYY'))
const clock = ref(moment().format('HH:mm:ss'))

onMounted(() => {
    store.dispatch('lokasi/getLokasi')
    setInterval(() => {
        date.value = moment().format('dddd, DD MMMM YYYY')
        clock.value = moment().format('HH:mm:ss')
    }, 1000);
})

const anyLokasi = computed(() => { return store.state.lokasi.lokasi })
const anyTanggal = computed(() => { return store.state.lokasi.tanggal })

function cariKota(){
    store.dispatch('lokasi/getLokasi', input.value)
}

function toSlug() {
  message.value = messageRaw.value.toString()
    .replace(/\s+/g, '-')           // Replace spaces with dash
    // .replace(/[^\w\-]+/g, '')       // Remove all non-word characters
    // .replace(/\-\-+/g, '-')         // Replace multiple dashes with single dash
    .replace(/^-+/, '')             // Trim leading dash
    .replace(/-+$/, ''); 
}
</script>